Imports System.Data
Imports System.Xml
Imports System.Xml.XmlDataDocument
Imports System.Data.OleDb
Imports System.Data.SqlTypes
Imports System.Text
Imports System.IO

Public Class Form1
    Private PlayAgain As Boolean
    ' This is to start the dataset for the music beat sequences
    Dim ds As New DataSet(), dr As DataRow, dt As DataTable
    'holds a deleted record
    Dim titlehold As String, descriptionhold As String
    'holds the current filename
    Dim schemafilepath As String, datafilepath As String
    'holds the total records and current record number
    Dim totalrows As Integer, currentrow As Integer, stepp As Integer
    Dim at As Integer

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' This code enables the startup settings of the Media Player
        AxWindowsMediaPlayer1.settings.autoStart = True
        AxWindowsMediaPlayer1.settings.volume = TrackBar1.Value
        AxWindowsMediaPlayer1.settings.enableErrorDialogs = False
        AxWindowsMediaPlayer1.enableContextMenu = False
        Label2.Text = TrackBar1.Value

        'create a new table named Recipes with title and description
        '(the description of the actual recipe) columns.
        dt = New DataTable("sequence")
        dt.Columns.Add("beat", GetType(String))
        dt.Columns.Add("channel", GetType(String))
        ds.Tables.Add(dt)
        dt = ds.Tables!sequence

        'totalrows = dt.Rows.Count
        'currentrow = 0
        'TextBox1.Text = totalrows
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        ' Search for Channel to set high at each pulse.
        currentrow = currentrow + 1
        TextBox2.Text = currentrow
        'loadnewrow()
        findchannel()
        TextBox7.Text = Duration.Text
        ' Update the trackbar.
        Dim CurPos As Integer = Convert.ToInt32(AxWindowsMediaPlayer1.Ctlcontrols.currentPosition * 1000) ' milliseconds
        Dim DurationVar As Integer = Convert.ToInt32(AxWindowsMediaPlayer1.currentMedia.duration * 1000) ' milliseconds
        If DurationVar > 0 Then
            PlayBar.Value = Convert.ToInt32((CurPos * 91) / DurationVar) ' % complete
        End If
        ' Update the time label
        Dim CurPos1 As Integer = Convert.ToInt32(AxWindowsMediaPlayer1.Ctlcontrols.currentPosition * 10)
        Duration.Text = CurPos1 'PlayerControl.Ctlcontrols.currentPositionString
        ' txtEmployeeID.Text = CurPos1
        If AxWindowsMediaPlayer1.playState = WMPLib.WMPPlayState.wmppsStopped Then
            Duration.Text = "00:00"
            Timer1.Enabled = False
            PlayBar.Value = 0
        End If
        If PlayAgain = False Then
        Else
            If AxWindowsMediaPlayer1.playState = WMPLib.WMPPlayState.wmppsStopped Then
                PlaySong()
            Else
            End If
        End If
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        PlaySong()
    End Sub

    Private Sub PlaySong()
        If AxWindowsMediaPlayer1.URL <> "" Then
            AxWindowsMediaPlayer1.Ctlcontrols.play()
            Timer1.Enabled = True
        Else
            Timer1.Enabled = False
        End If
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        GetFile()
    End Sub

    Private Sub GetFile()
        If OpenFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK And OpenFileDialog1.FileName <> "" Then
            AxWindowsMediaPlayer1.URL = OpenFileDialog1.FileName
            Timer1.Enabled = True
            Label8.Text = OpenFileDialog1.FileName
        End If
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        StopSong()
    End Sub

    Private Sub StopSong()
        AxWindowsMediaPlayer1.Ctlcontrols.stop()
        Duration.Text = "00:00"
        Timer1.Enabled = False
        PlayBar.Value = 0
        currentrow = 0
        stepp = 0
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        PauseSong()
    End Sub

    Private Sub PauseSong()
        AxWindowsMediaPlayer1.Ctlcontrols.pause()
        Timer1.Enabled = False
    End Sub

    Private Sub TrackBar1_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar1.Scroll
        AxWindowsMediaPlayer1.settings.volume = TrackBar1.Value
        Label2.Text = TrackBar1.Value
    End Sub

    Private Sub PlayBar_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles PlayBar.Scroll
        Try
            If (AxWindowsMediaPlayer1.currentMedia.duration <> 0) Then
                Dim NewPerc As Double = Convert.ToDouble(PlayBar.Value) / 100
                Dim DurationVar As Integer = Convert.ToInt32(AxWindowsMediaPlayer1.currentMedia.duration * 100) ' milliseconds
                Dim NewPos As Integer = (DurationVar * NewPerc) / 100
                AxWindowsMediaPlayer1.Ctlcontrols.currentPosition = NewPos
            Else
                PlayBar.Value = 0
            End If
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Dim CloseMessage As DialogResult
        CloseMessage = MsgBox("Close Music Sequener Controller?", MsgBoxStyle.YesNo)
        If CloseMessage = Windows.Forms.DialogResult.Yes Then
            AxWindowsMediaPlayer1.Ctlcontrols.stop()
            'If serialPort.IsOpen Then
            'serialPort.Close()
        End If
        'End If
        If CloseMessage = Windows.Forms.DialogResult.No Then
            e.Cancel = True
        End If
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        up()
    End Sub

    Private Sub up()
        Dim pos As Int64
        Dim pos1 As Int64
        currentrow = currentrow + 1
        pos = totalrows - 1
        If currentrow > pos Then
            pos1 = 0
            currentrow = 0
        Else : pos1 = currentrow
        End If
        If currentrow > 0 Or totalrows Then
            TextBox2.Text = currentrow
            TextBox3.Text = dt.Rows(pos1).Item(0)
            TextBox4.Text = dt.Rows(pos1).Item(1)
        Else
            MsgBox("No Beats to choose from.")
        End If
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        currentrow = currentrow - 1
        If currentrow = -1 Then
            currentrow = 0
        End If
        TextBox2.Text = currentrow
        If currentrow > 0 Then
            TextBox3.Text = dt.Rows(currentrow).Item(0)
            TextBox4.Text = dt.Rows(currentrow).Item(1)
        End If

    End Sub

    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        loadnewrow()
    End Sub

    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        deleterow()
    End Sub

    Private Sub deleterow()
        If totalrows > currentrow Then
            dt.Rows.RemoveAt(currentrow)
            totalrows = dt.Rows.Count
            TextBox1.Text = totalrows
            ds.WriteXmlSchema("c:\" & Label10.Text & "dataset.xml")
            ds.WriteXml("c:\" & Label10.Text & "data.xml")

        End If
    End Sub

    Private Sub Button9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button9.Click
        findchannel()
    End Sub

    Private Sub loadnewrow()
        If CheckBox1.Checked = True Then
            TextBox6.Text = "1"
        ElseIf CheckBox1.Checked = False Then
            TextBox6.Text = "0"
        End If
        If CheckBox2.Checked = True Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox2.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox3.Checked = True Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox3.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        If CheckBox4.Checked = True Then
            TextBox6.Text = TextBox6.Text + "1"
        ElseIf CheckBox4.Checked = False Then
            TextBox6.Text = TextBox6.Text + "0"
        End If
        dr = dt.NewRow
        dr!beat = Duration.Text
        dr!channel = TextBox6.Text
        dt.Rows.Add(dr)
        ds.WriteXmlSchema("c:\" & Label10.Text & "dataset.xml")
        ds.WriteXml("c:\" & Label10.Text & "data.xml")
        totalrows = dt.Rows.Count
        TextBox1.Text = totalrows
    End Sub

    Private Sub findchannel()
        For Each dr In dt.Rows
            If dr!beat = TextBox7.Text Then
                TextBox3.Text = dr!beat
                TextBox4.Text = dr!channel
            End If
        Next
    End Sub

    Private Sub Button10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button10.Click
        Form4.Show()
    End Sub

    Private Sub AboutToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutToolStripMenuItem1.Click
        Form3.Show()
    End Sub

    Public Sub creatdataset()
        ' This allows you to create a new dataset in the C: drive
        ds.WriteXmlSchema("c:\" & Label10.Text & "dataset.xml")

        'This allows you to create new set of data in the dataset into the C: drive
        ds.WriteXml("c:\" & Label10.Text & "data.xml")

        totalrows = dt.Rows.Count
        currentrow = 0
        TextBox1.Text = totalrows
    End Sub

    Public Sub loaddatasets()
        ' This allows you to read the dataset back from the C: drive
        If Not (System.IO.File.Exists("c:\" & Label10.Text & "dataset.xml")) Then
            ds.WriteXmlSchema("c:\" & Label10.Text & "dataset.xml")
        Else
            ds.ReadXmlSchema("c:\" & Label10.Text & "dataset.xml")
        End If

        If Not (System.IO.File.Exists("c:\" & Label10.Text & "data.xml")) Then
            ds.WriteXml("c:\" & Label10.Text & "data.xml")
        Else
            ds.ReadXml("c:\" & Label10.Text & "data.xml")
            totalrows = dt.Rows.Count
            TextBox1.Text = totalrows
        End If

        currentrow = 0
        TextBox2.Text = currentrow

    End Sub

    Private Sub TextBox4_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox4.TextChanged
        stepp = stepp + 1
        TextBox9.Text = stepp
        'CheckBox1.CheckState = CheckState.Checked

    End Sub

    Private Sub Button11_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button11.Click
        deleterow()
        updaterow()
    End Sub

    Private Sub updaterow()
        'This is how to update a Row in a Dataset modify the star in (dr,*) too which row you  
        ' want to update.
        'If totalrows > currentrow Then
        dr = dt.NewRow
        dr!beat = TextBox3.Text 'Duration.Text
        dr!channel = TextBox6.Text
        dt.Rows.InsertAt(dr, currentrow)
        ds.WriteXmlSchema("c:\" & Label10.Text & "dataset.xml")
        ds.WriteXml("c:\" & Label10.Text & "data.xml")
        totalrows = dt.Rows.Count
        TextBox1.Text = totalrows
        'End If
    End Sub

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged

    End Sub
End Class
